package td03;

public class Point2DCartesien implements Point2D{

	private double x;
	private double y;

	public Point2DCartesien(double x, double y){
		this.x = x;
		this.y = y;
	}

	public Point2DCartesien(Point2D p){
		this(p.getAbscisse(), p.getOrdonnee());
	}

	public Point2DCartesien(){
		this(0,0);
	}

	public double getAbscisse(){
		return this.x;
	}

	public void setAbscisse(double x){
		this.x = x;
	}

	public double getOrdonnee(){
		return this.y;
	}

	public void setOrdonnee(double y){
		this.y = y;
	}

	public double getModule(){
		return Math.sqrt(this.x*this.x+this.y*this.y);
	}

	public void setModule(double module){
		double arg = this.getArgument();
		setAbscisse(module * Math.cos(arg));
		setOrdonnee(module * Math.sin(arg));
	}

	public double getArgument(){
		return Math.atan2(this.y,this.x);
	}

	public void setArgument(double argument){
		double m = this.getModule();
		setAbscisse(m * Math.cos(argument));
		setOrdonnee(m * Math.sin(argument));
	}

	// Pour des réels, pas de "vraie" égalité mais test à epsilon près
	public boolean equals(Point2D p){
		return Math.abs(this.x-p.getAbscisse()) <EPSILON &&  
				Math.abs(this.y - p.getOrdonnee()) < EPSILON;
	}

	public String toString(){
		return " [x = " + x + ", y = " + y + "]";
	}

	public Point2D clone(){
		return new Point2DCartesien (x, y);
	}


	public void translation (double dx, double dy){
		x += dx;
		y += dy;
	}

	public void homothetie(double rapport){
		this.x *= rapport;
		this.y *= rapport;
	}

	public void rotation(double angle){
		double abs = Math.cos(angle)*this.x - Math.sin(angle)*this.y;
		double ord = Math.sin(angle)*this.x + Math.cos(angle)*this.y;
		this.x = abs;
		this.y = ord;
	}

}
