package td03;

public class Point2DPolaire implements Point2D{

	private double module;
	private double argument;

	public Point2DPolaire(double module, double argument){
		this.module = module;
		if (module == 0)
			argument = 0;
		this.argument = normalise (argument);
	}

	public Point2DPolaire(Point2D p ){
		this(p.getModule(), p.getArgument());
	}

	public Point2DPolaire(){
		this(0, 0);
	}

	// cette normalisation permet d'avoir un argument entre -PI et PI
	private static double normalise(double argument){
		while (argument >  Math.PI)
			argument -= 2 * Math.PI;
		while (argument <= -Math.PI)
			argument += 2 * Math.PI;
		return argument;
	}

	public double getAbscisse(){
		return this.module * Math.cos(this.argument);
	}

	public void setAbscisse(double x){
		double y = this.getOrdonnee();
		this.setModule(Math.sqrt(x*x+y*y));
		this.setArgument(Math.atan2(y,x));
	}

	public double getOrdonnee(){
		return this.module * Math.sin(this.argument);
	}

	public void setOrdonnee(double y){
		double x = this.getAbscisse();
		this.setModule(Math.sqrt(x*x+y*y));
		this.setArgument(Math.atan2(y,x));
	}

	public double getModule(){
		return this.module;
	}

	public void setModule(double m){
		this.module = m;
	}

	public double getArgument(){
		return this.argument;
	}

	public void setArgument(double a){
		this.argument = a;
	}

	// Pour des réels, on ne doit pas utiliser une vraie égalité
	// mais une  égalité à EPSILON près

	public boolean equals(Point2D p){
		return Math.abs(this.module - p.getModule()) < EPSILON && 
				Math.abs(this.argument - p.getArgument()) < EPSILON;
	}

	public String toString(){
		return " [ m = " + module + ", arg = " + argument + "]";
	}

	public Point2D clone(){
		return new Point2DPolaire(this);
	}

	public void translation(double dx, double dy) {
		double x = this.getAbscisse();
		double y = this.getOrdonnee();
		x += dx;
		y += dy;
		module = Math.sqrt(x*x+y*y);
		argument = Math.atan2(y,x);
	}

	public void homothetie(double rapport){
		this.module *= rapport;
		if (this.module == 0)
			this.argument = 0;
	}

	public void rotation(double angle){
		this.argument += angle;
		this.argument = normalise(this.argument);
	}

}
